<?
// very basic ftp connection class
class ftpcnx {
	var $ftphost;
	var $ftpport;
	var $ftpuser;
	var $ftppassword;
	var $ftptimeout;
	var $ftpname;
	var $ftpcnx;
	var $ftplink;
	var $ftptranstype;

  // connect to FTP
	function connect($user="anonymous", $pass="", $host="localhost", $port="21", $timeout="90", $type=FTP_BINARY) {
		$this->ftpuser = $user;
		$this->ftppassword = $pass;
		$this->ftphost = $host;
		$this->ftpport = $port;
		$this->ftptimeout = $timeout;
		$this->ftptranstype = $type;

		$this->ftphost = gethostbyname($this->ftphost);
		$this->ftpcnx = ftp_connect($this->ftphost, $this->ftpport);
		if(!$this->ftpcnx) return false;

		if(!ftp_login($this->ftpcnx, $this->ftpuser, $this->ftppassword)) return false;
		if(!ftp_pasv($this->ftpcnx, 1)) return false;

		return true;
	}

  // Set FTP transertype
	function UseTransferType() {
		$this->ftptranstype = FTP_BINARY;
	}

  // Upload files to FTP
	function upload($dest, $src) {
		return ftp_put($this->ftpcnx, $dest, $src, $this->ftptranstype);
  }

  // Download files from FTP
	function download($src, $dest) {
		return ftp_get($this->ftpcnx, $dest, $src, $this->ftptranstype);
  }

  // Delete a file or directory on FTP
	function delete($file) {
		return ftp_delete($this->ftpcnx, $file);
  }

  // Change a directory on FTP
	function dir($dir) {
		return ftp_chdir($this->ftpcnx, $dir);
  }

  // List files and dirs on FTP
	function dirlist($dir=".") {
		return ftp_nlist($this->ftpcnx, $dir);
  }

  // Create a directory on FTP
	function makedir($dir) {
		return ftp_mkdir($this->ftpcnx, $dir);
  }

  // Go on directory higher on FTP
	function up() {
		ftp_cdup($this->ftpcnx);
  }

  // Close the ftp connection
	function close() {
		ftp_close($this->ftpcnx);
  }
}

// Define class
$ftp = new ftpcnx();

function ftpupdate()
{
	global  $ftp, $ftp_uname, $ftp_upass, $ftp_hostname, $ftp_port,
		$ftp_delete, $ftp_movedir, $ftp_dir, $ftp_extension;

  // Update, from here on were going to be doing multiple FTP sessions.
  for ($i = 0; $i < count($ftp_hostname); $i++) {

    // Try to connect to the ftp.
	  if(!$ftp->connect($ftp_uname[$i], $ftp_upass[$i], $ftp_hostname[$i], $ftp_port[$i])) return;

		echo'<table border="0" cellpadding="1" cellspacing="2" width="720">
		<tr>
			<td class="smheading" align="center" height="25" width="550" colspan="2">FTP Transferring Log Files</td>
	  </tr>
	  <tr>
		<td class="smheading" align="left" width="350">Connecting to Server:</td>
		<td class="grey" align="left" width="200">'.$ftp_hostname[$i].'</td>
	  </tr>
	  <tr>
		<td class="smheading" align="left" width="350">Downloading File(s)</td>
		<td class="grey" align="left" width="200">';

    // Return if FTP dir is not found or $ftp_dir in the config is not set.
	  if($ftp_dir && !$ftp->dir($ftp_dir[$i])) return;

    // Set the $list var with the files, Return if there is a empty dir.
	  if(!($list = $ftp->dirlist())) return;

    // Download the files in the $list var. And move them if $ftp_movedir is set

	  foreach($list as $file) {
      if(substr($file, -4, 4) == $ftp_extension) {

		$file = str_replace("./", "", "$file");
		echo''.$file.'<br />';

        $ftp->download($ftp_dir[$i] . '/' . $file, 'logs/' . $file);
        $ftp->delete($file);
	  }
    }
      echo'</td>
		</tr>
		<tr><td class="" align="center" height="25" width="550" colspan="2"></td>
	  </tr>';

    // Close the Ftp connection
	  $ftp->close();
  }

	//update timestamp
	$file = fopen('includes/ftptimestamp.php', 'wb', 1);
	fwrite($file, time());
	fclose($file);
}


if(isset($ftp_use) && $ftp_use)
{
	$fname = 'includes/ftptimestamp.php';
	$timestamp = 0;

	if(file_exists($fname))
	{
		$file = fopen($fname, 'rb');
		$timestamp = trim(fgets($file));
		fclose($file);
	}

	if(!$timestamp || (time() - $timestamp) > $ftp_interval*60) {
   ftpupdate();
  }
}

?>